# Recipe (recipes/*.yaml)
- title - **MANDATORY**, string
- ingredients - list of [Simplified Ingredients](#simplified-ingredient) and [Ingredients](#ingredient)
- steps - list of strings and [Steps Sections](#steps-section)
- subrecipes - list of [Recipes](#recipe-recipesyaml)

## Simplified Ingredient
= string in a specific format
```
[amount unit] ingredient name [(note)]
```
[] means these sections are optional

* `amount` - number
* `unit` - a single word string
* `name` - string with arbitrary content
* `note` - string with arbitrary content, but has to be enclosed in parentheses, otherwise it will be considered to be part of `name`

for example, valid values are:
```
1 piece carrot (sliced)
^ amount
  ^---^ unit
        ^----^ ingredient name
               ^-----^ note
```
```
200 gram green onion
^-^ amount
    ^--^ unit
         ^---------^ ingredient name
```
```
apple
^---^ ingredient name
```
```
apple (red)
^---^ ingredient name
      ^---^ note
```

When amount and unit is not in the string, it is assumed to be `1 piece`.

## Ingredient
- name - **MANDATORY**, string, name has to be listed in ingredients.yaml if ingredients.yaml exists
- amount - number
- unit - string, unit has to be listed in units.yaml if units.yaml exists
- or - list of [Ingredient](#ingredient)
- note - string

## Steps Section
- section - **MANDATORY**, string, section name
- steps - list of strings
