# Ingredients

Similar to `units.yaml`, also `ingredients.yaml` is not a mandatory file, but having it gives us several advantages.
* spelling mistakes are not silently ignored, if something is not listed in ingredients.yaml, comfyrecipes will warn you
* we can use aliases - different names referring the same ingredient
* we will be able to add some more data to ingredients that will allow us to calculate prices (described in [Prices and Conversions](./pricesconversions.md))

```
- myrecipes/
    - recipes/
        - pancakes.yaml
    ...
    - ingredients.yaml (we will be creating this file)
```

We will again use the final recipe from [Quick Start](quickstart.md).

`🗎 myrecipes/recipes/pancakes.yaml:`
```yaml
{{#include ../../examples/firstrealrecipe.yaml}}
```

If you don't want to write the file manually, we can generate it using:
```sh
$ comfyrecipes generate-ingredients
```

This will generate a minimal ingredients.yaml:

`🗎 myrecipes/ingredients.yaml:`
```yaml
- name: all purpose flour
- name: butter
- name: egg
- name: milk
- name: white sugar
```

Now, let's say we would want to call `all purpose flour` just `flour`, we can add an alias:

`🗎 myrecipes/ingredients.yaml:`
```yaml
- name: all purpose flour
  aliases:
    - flour
- name: butter
- name: egg
- name: milk
- name: white sugar
```

Now whenever we add an ingredient called flour, it will be a reference to `all purpose flour`.

For a full reference for what an ingredients yaml can contain, please see the [Ingredients Reference](../reference/ingredients.md)
