# Quick Start

Let's start writing recipes. First, create the directory structure that will hold all our input data.

```
- myrecipes/
    - recipes/
        - pancakes.yaml
```

Now when we have the structure created, let's create the most minimal possible `pancakes.yaml`:

`🗎 myrecipes/recipes/pancakes.yaml:`
```yaml
{{#include ../../examples/minimal.yaml}}
```

And render it by running:
```sh
$ comfyrecipes build myrecipes
```

This will create a new directory `out/` in `myrecipes/` containing the built data.
```
- myrecipes/
    - out/
        - html/
            - index.html
            - pancakes.html
    - recipes/
        - pancakes.yaml
```

We can see the result if we start a web server pointing to that directory, for example by using:
```sh
$ comfyrecipes serve myrecipes
```
and navigate to <http://127.0.0.1:8000/>

`serve` should NOT be used in production.

While that was a valid recipe, it's not very useful and we can only see the title. Let's improve that:

`🗎 myrecipes/recipes/pancakes.yaml:`
```yaml
{{#include ../../examples/minimalusable.yaml}}
```

* each ingredient is a step in the format `amount unit name`
    * `amount` has to be a number
    * `unit` has to be a single word
    * `name` can be a string with arbitrary content
    * for a full description of this format, please see the [Reference section](../reference/recipe.md#simplified-ingredient)
* each step is a string with arbitrary content

And again, build, make sure the server is running and navigate to <http://127.0.0.1:8000/>. From now on, we will assume you know how to build and serve your output directory.

Once more, let's improve the recipe once again to something that can actually be made and is not just a demo. This does not introduce any new concepts compared to the last recipe we wrote.

`🗎 myrecipes/recipes/pancakes.yaml:`
```yaml
{{#include ../../examples/firstrealrecipe.yaml}}
```

For a full reference for what a recipe yaml can contain, please see the [Recipe Reference](../reference/recipe.md)
